Name:      ovs-agent
Version:   2.2
Release:   86
Summary:   Agent for Oracle VM
License:   GPL
Group:     System Environment/Daemons
URL:       http://www.oracle.com/virtualization
Source:    %{name}-%{version}.tar.bz2
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires:  python >= 2.4
Requires:  compat-python-virtinst
Requires:  ovs-utils

%description
This is the Agent daemon for Oracle VM. It handles the
actual Virtual Machine operations in the backend.

%prep
%setup -q

%build
make build

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=${RPM_BUILD_ROOT} install
mkdir -p ${RPM_BUILD_ROOT}/etc/init.d
install --mode=755 ovs-agent.init ${RPM_BUILD_ROOT}/etc/init.d/ovs-agent

%clean
rm -rf $RPM_BUILD_ROOT

%post
#http://www.ibm.com/developerworks/linux/library/l-rpm3.html
if [ "$1" = 1 ]; then
    /sbin/chkconfig --add ovs-agent
fi

#configure agent with default value, mainly for
#1) regenerating admin password
#2) if upgrade, update the default config file
/etc/init.d/ovs-agent configure >/dev/null <<EOF





EOF

# this script autogenerates a key for the agent for SSL configuration
# we use the hostname as extra data
if [ ! -f "/etc/ovs-agent/cert/key.pem" -o ! -f "/etc/ovs-agent/cert/certificate.pem" ]; then
    _hostname=$(uname -n)
    cd /etc/ovs-agent/cert
    openssl genrsa -out key.pem 1024
    openssl req -new -key key.pem -out request.pem << EOF
.
.
.
.
.
${_hostname}
.
.
.
EOF
    openssl x509 -req -days 1000 -in request.pem -signkey key.pem -out certificate.pem
fi

if ! LC_ALL=C grep -q "^(xend-domains-lock-path \+/opt/ovs-agent-2.2/utils/dlm.py)" /etc/xen/xend-config.sxp 2>/dev/null ; then
    LC_ALL=C grep -v "^(xend-domains-lock-path" /etc/xen/xend-config.sxp >/tmp/xend-config.sxp 2>/dev/null
    echo "(xend-domains-lock-path /opt/ovs-agent-2.2/utils/dlm.py)" >>/tmp/xend-config.sxp
    /bin/mv /tmp/xend-config.sxp /etc/xen/xend-config.sxp
    if xend status >/dev/null 2>&1 ; then
        vms=`xm list 2>/dev/null |wc -l`
        if [ "$vms" = "2" ]; then
            service xend restart >/dev/null 2>&1
        else
            echo "There are running VMs. Please shutdown the VMs and restart xend manually."
        fi
    fi
fi

%preun
if [ "$1" = 0 ]; then # execute this only if we are NOT doing an upgrade
    /sbin/service ovs-agent stop --force --disable-nowayout >/dev/null 2>&1
    /sbin/chkconfig --del ovs-agent
    if LC_ALL=C grep -q "^(xend-domains-lock-path \+/opt/ovs-agent-2.2/utils/dlm.py)" /etc/xen/xend-config.sxp 2>/dev/null ; then
        LC_ALL=C grep -v "^(xend-domains-lock-path \+/opt/ovs-agent-2.2/utils/dlm.py)" /etc/xen/xend-config.sxp >/tmp/xend-config.sxp 2>/dev/null
        /bin/mv /tmp/xend-config.sxp /etc/xen/xend-config.sxp
        if xend status >/dev/null 2>&1 ; then
            vms=`xm list 2>/dev/null |wc -l`
            if [ "$vms" = "2" ]; then
                service xend restart >/dev/null 2>&1
            else
                echo "There are running VMs. Please shutdown the VMs and restart xend manually."
            fi
        fi
    fi
fi

%files
%defattr(-,root,root)
/etc/init.d/ovs-agent
/opt/%{name}-%{version}

%changelog
*Wed Jun 10 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-86
- bugfix in ha_generate_ocfs2_cluster_conf().

*Wed Jun 10 2009 Tiger Zhang <tiger.zhang@oracle.com> - 2.2-86
- Add a logger ovs.debug. Change logger to local.

*Fri Jun 5 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-85
- OCFS2 cluster configuration generation enhancement.

*Thu Jun 4 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-84
- add a new agent configuration option for error messages.
- fmt_err_msg() enhancement.

*Wed Jun 3 2009 Zhigang Wang <zhigang.x.wang@oracle.com> - 2.2-83
- update ovs-agent.spec

* Tue Jun 2 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-82
- [bugz 8542], rewrite external xend lock mechanism.
- rewrite shared storage check.

* Sun May 31 2009 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-81
- [bugz 9194], "timer_mode" parameter is not set properly by Agent/manager for 64 bit guest in rc2

* Fri May 22 2009 Tiger Zhang <tiger.zhang@oracle.com> - 2.2-80
- [bugz 8472], add logs in agtctl.

*Wed May 13 2009 Hongxi Ma <hongxi.ma@oracle.com>, Tiger Zhang <tiger.zhang@oracle.com>, Junjie Wei <junjie.wei@oracle.com> - 2.2-79
- rewrite run_cmd() to fix the cmd injection vulnerability.
- add unittest for some of the APIs.

*Tue May 12 2009 Junjie Wei <junjie.wei@oracle.com> -2.2-79
- [bugz 8970], get memory infomation from `xm info`

*Fri May 8 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-79
- rewrite get_agent_version(), returns version of the running agent

*Fri Apr 30 2009 Junjie Wei <junjie.wei@oracle.com> -2.2-78
- [bugz 8797], sync dlm locks when ha is enabled/disabled or agent starts; introduces dlm db.
- [bugz 8831], typo in get_host_info().
- [bugz 8725], remove .listing file when processing ftp directory download.
- [bugz 8860], do not allow to package/cp vm with device-based disks. allow tap:aio type device-based disks.
- set wget time out to 10 seconds and tries to 2.
- typo in ha_set_shutdown_mode()
- [bugz 8762], introduce threading to avoid monitor process blockage.

*Mon Apr 20 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-77
- get_storage_repositories() enhancement: cluster shared storage root entry probe.

*Thu Apr 16 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-76
-[bugz 8649, 8597], sync cluster shared storage settings to new servers in the cluster when cluster HA is enabled.

*Thu Apr 9 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-75
- [bugz 8657], use synchronous run_cmd instead of asyncronous rum_cmd_bg to avoid database update lost.

*Tue Mar 31 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-74
- WLOC perf metrics collection. affected api list below,
  get_vm_perf_metrics()
  get_server_perf_metrics()
  get_server_xm_info()
  get_storage_repositories()
  get_live_vm_info()

*Mon Mar 30 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-73
- [bugz 8460], pad number with leading zero when generate mac

*Mon Mar 16 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-72
- [bugz 6757], add ha_remove_cluster_infrastructure()

*Wed Mar 11 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-71
- [bugz 7048,7457],[bug 8229141], add ovs-agent to /var/lock/subsys/ to 
  stop agent properly when user manually shutdown the server.

*Mon Mar 9 2009 Tiger Zhang <tiger.zhang@oracle.com> - 2-2.70
- [bugz 8116], V2V importing failed. Fixed. Duplicate [bugz 7583].

*Sat Mar 7 2009 Dyno Fu <dyno.fu@oracle.com> - 2-2.70
- [bugz 8269], generated cluster.conf has duplicated hostname.

*Thu Mar 5 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-70
- [bugz 8263], use --no-p option to keep destination permissions

*Tue Mar 3 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-70
- new api to get all registered servers in the server pool: get_registered_servers()

* Tue Feb 27 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-70
- modify db_get_real_vm_path() to solve nfs not sync problem [bugz 8108,6759].

* Thu Feb 26 2009 Junjie Wei <junjie.wei@oracle.com> -2.2-70
- bugfix of check_sys_passwd(), change destination file name.

* Fri Feb 20 2009 Junjie Wei <junjie.wei@oracle.com> - 2.2-69
- [bugz 8103], return the server on which the operation is done for
  install_vm_hvm/para(), start_vm()
- [bugz 8143], when attaching a shared disk to a vm, use force attach option "!".
- [bugz 8144], use mode option "!" instead of string "shareddisk" for shared disk check

* Tue Feb 17 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-69
- [bugz 8108], use the hostserver where the vm is currently running to get the realpath
  to workaround the nfs sync problem as in [bugz 6759].
  get_vm_vnc_conn(), get_vm_config()

* Thu Feb 12 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-68
- [bugz 8056], adjust remove sequence, put the error prone detatch first.

* Mon Feb 09 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-67
- [bugz 7657,7835], for a paused vm, xm shutdown won't work. unpause it before doing that.

* Wed Feb 04 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-66
- [bugz 7991], xen_get_vms_name_vncport_macs() exception when vncport cannot be retrieved
  from xenstore.

* Mon Jan 12 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-65
- [bugz 7822], get_live_vms() should restore timout setting.

* Mon Jan 12 2009 Dyno Fu <dyno.fu@oracle.com> - 2.2-65
- [bugz 7296], register server reuse what already in db, rather than raise Exception.

* Wed Dec 24 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-64
- [bugz 7646], import running vm, use the original uuid.

* Wed Dec 24 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-63
- enhance utl_extract_vm() to deal with vm tarball inside directory.

* Mon Dec 22 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-63
- [bugz 7728, 7729] implement utl_nfs_cp()
- [bugz 7646], after create a vm from scratch, create a uuid if not available already.

* Wed Dec 17 2008 Junjie Wei <junjie.wei@oracle.com> - 2.2-62
- [bugz 7602, 7661] add a new api config_vm(), to configure the guest vm
- [bugz 7606] add a new api copy_props_into_vm(), to generate a property file and copy it into the vm

* Tue Dec 16 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-62
- [bugz 7674], implement get_vm_policy()/get_vm_attr()

* Fri Dec 12 2008 Junjie Wei <junjie.wei@oracle.com> - 2.2-61
- add OVSImageOperation.py, copyFileIntoVM()

* Wed Dec 10 2008 Tiger Zhang <tiger.zhang@oracle.com> - 2.2-61
- [bugz 7484], add a new API named xen_get_cdrom_frontend for getting front end name of cdrom device.

* Tue Dec 09 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-61
- replace uuid gen with get_uuid()
- [bugo 7626690][bugz 7649], only sync ocfs2 cluster configure to the newly
  registered server when ha is enabled.
- [bugz 7603], nfs_export_iso() utl_nfs_export_iso()

* Mon Dec 01 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-61
- implement get_vm_perf_metrics() and get_server_perf_metrics()

* Wed Nov 26 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-61
- cleanup source code file name.

* Wed Nov 26 2008 Junjie Wei <junjie.wei@oracle.com> - 2.2-61
- add get_server_config() and get_network_config()
- add a new file OVSXAPIUtil.py

* Mon Nov 24 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-61
- move dispatch service to OVSServices
- integrate XenAPI to ovs-agent

* Thu Nov 20 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-60
- [bugz 7564], no return value for get_free_space_vm() when error occures.

* Thu Nov 13 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-60
- [bugz 7688], add ha_check_storage_cluster_root() for validation

* Tue Nov 04 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-59
- [bugz 7076], set rpc timeout to 15 in get_live_vms()

* Tue Nov 04 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-59
- [bugz 7338], after cp vm, duplate a db record and update 'manual_shutdown'
  to True. so that the newly created vm won't startup when HA enabled for it.

* Mon Nov 03 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-59
- [bugz 7344], remove oflag=direct, when specified will cause "Invalid argument".

* Fri Oct 31 2008 Hongxi Ma <hongxi.ma@oracle.com> 2.2-58
- [bugz 7365], After do the cancel operation, system.img is not deleted

* Tue Oct 28 2008 Dyno Fu <dyno.fu@oracle.com> 2.2-58
- [bugz 7362], dd on ext3 file system does not support "oflag=direct".

* Tue Oct 28 2008 Junjie Wei <junjie.wei@oracle.com> 2.2-58
- [bugz 7327], enhancement of get_host_info(), getting info before server registration supported

* Mon Oct 27 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-57
- [bugz 7332], using open-ovf tool to generate vm.cfg, env file, etc

* Fri Oct 24 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-57
- [bugz 7344], utl_cp_vm() now uses dd instead of copytree() for efficiency
- [bugz 7285], unregister server will remove the dlm lock line from xend-config.sxp

* Fri Oct 24 2008 Junjie Wei <junjie.wei@oracle.com> - 2.2-57
- [bugz 7297], implement update_sys_passwd() and check_sys_passwd()

* Thu Oct 23 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-57
- add new api: get_vm_config which return all the configs in vm.cfg in the format of XML

* Thu Oct 23 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-57
- [bugz 7296], implement update_agent_password()
- [bugz 7332], implement get/set_vm_ovf_env_file()
- when register_vm set manual_shutdown = True [bugz 7338]
  when detect vm is RUNNING set manual_shutdown = False [bugz 7276][bugz 7236]
  start the vm <=> vm is DOWN and manual_shutdown == False

* Wed Oct 22 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-57
- [bugz 7316], to add xen_correct_cfg in utl_cp_vm

* Tue Oct 21 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-57
- [bugz 7312], num_in_the_cluster -> num_in_cluster

* Mon Oct 20 2008 Junjie Wei <junjie.wei@oracle.com> - 2.2-56
- [bugz 6670], correct vm config file after creating a dummy vm for pvm pxe boot

* Wed Oct 15 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-56
- [bugz 7276], ha feature does not work for manually started vm.

* Tue Oct 14 2008 Tiger Zhang <tiger.zhang@oracle.com> - 2.2-56
- [bugz 7141], add setting add os type and variant.
- Fixed bug in vmx parser in case when account of sections is more than 2. (e.g. vmware.tools.version = "7702")

* Thu Oct 08 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-55
- api list_dir is enhanced to support an exta param: level which takes a default vaule 1

* Tue Oct 07 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-54
- [bugz 7236], for an already running vm, import it and enable ha does not take effect.

* Mon Oct 06 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-54
- delete member nodes first when unregister master node.

* Wed Sep 24 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-53
- [bugz 4103], filter server without hvm capability when install hvm vm from scratch.

* Tue Sep 23 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-52
- [bugz 5835], set_vm_config_param(), for pass extra parameter to vm.cfg

* Tue Sep 16 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-52
- [bugz 7076], change server's status in OVSMonitorServer.check_server_status()

* Wed Sep 03 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-52
- [bugz 7048], disable nowayout when shutdown the server from agent.

* Mon Sep 01 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-52
- [bug 7357167], deal with memory over allocate problem
- [bugz 7032], make the master node have the minest node num in ocfs2 cluster conf

* Fri Aug 29 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-52
- [bugz 7027], when the master agent goes live, call ha_setup_cluster_infrastructure()

* Thu Aug 28 2008 Tiger Zhang <tiger.zhang@oracle.com> - 2.2-51
- [bugz 7015], correct a typo.

* Wed Aug 27 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-51
- [bugz 6759], cannot find real vm path due to nfs sync problem.
- get_host_by_name() to get the non-local ip

* Tue Aug 26 2008 Tiger Zhang <tiger.zhang@oracle.com> - 2.2-51
- [bugz 6503], remove vm.cfg when error occurred in v2v converting.

* Tue Aug 26 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-51
- remove --ignore-length parameter, will have fix in the p2v server side.
- [bugz 6891], deal with existing hdc device in xen_correct_cfg(), which in qemu is reverved for cdrom.
- also affect xen_change_vm_cdrom(), xen_get_avail_disk_slot()

* Mon Aug 25 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-51
- [bugz 6399], xen_set_vifs() will retain the extra attributes it does not understand.

* Mon Aug 25 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-50
- update rcp.py for "rsync error:"

* Mon Aug 25 2008 Tiger Zhang <tiger.zhang@oracle.com> - 2.2-50
- add wget parameter --ignore-length for the file in p2v is a link
- set xm shutdown timeout before destroy from 10 mins to 5 mins

* Wed Aug 20 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-49
- [bugz 6962], use uuid as lock string. name will be vary during vm life cycle.
- [bugz 6853], on_error should NEXT rather than raise Exception.

* Tue Aug 19 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-49
- [bugz 6759], sync_file_attr() after create the vm disk
- [bugz 6953], add comment to explain ip access control is in CIDR format.
- remove duplicated functions xen_create/delete_disk() in OVSXXenVM which is also in OVSXUtility

* Thu Aug 14 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-48
- [bugz 6936], only if the path is under 'dev' then ignore the check

* Thu Aug 14 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-48
- [bugz 6913], remove the remote host from known_hosts to avoid host key verification error.
- [bugz 6865], filter virbr## in xen_get_network_bridges()

* Tue Aug 12 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-48
- add tries=2 to limit max test_url awaiting time to 60s

* Tue Aug 12 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-48
- [bugz 6915], add cancel option in shutdown mode

* Fri Aug 8 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-48
- [bugz 6758], to bypass wget bug(not use '--directory-prefix' sometimes)

* Thu Aug 7 2008 Tiger Zhang <tiger.zhang@oracle.com>
- [bugz 6891], skip hdc to reserve it for cdrom as a workaround.
- [bugz 6802], fixed.

* Wed Aug 6 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-48
- [bugz 6737], close_fds option for run_cmd_bg()
- revise agtctl stop process for ha
- [bugz 6888], service o2cb configure take the $cluster_name as default

* Tue Aug 5 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-47
- [bugz 6853], when no server selected to run a vm, donnot mark the vm as ERROR.
- [bugz 6877], revise implement of xen_get_vms_name_vncport_macs()

* Fri Aug 1 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-46
- use cached password to authanticate the API call
- config_agent.py will notify agent to reload cache, so that new password take effect
  immediately.
- "plz" --> "please"

* Fri Aug 1 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-46
- modify OVSCompat.py to change the the child process's python path

* Thu Jul 31 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-45
- [bugz 6758] Import iso failed due to wget timeout

* Thu Jul 31 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-45
- [bugz 6737], implement the nowayout lock in OVSAgentGuard.py,
  add --disable-nowayout option to agtctl.
- [bugz 6717], add node to living cluster.

* Mon Jul 28 2008 Dyno Fu<dyno.fu@oracle.com>,Hongxi Ma<hongxi.ma@oracle.com> - 2.2-45
- [bugz 6807], generate empty cluster.conf instead of complain no servers.
- [bugz 6808], consider multiple device with same uuid
- [bugz 6758], Import iso failed due to wget timeout
- [bugz 6817], HA enable, set save/restore vm as manual operation

* Sun Jul 27 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-45
- [bugz 6778] VIF Qos setting can not be deleted in vm.cfg

* Wed Jul 23 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-44
- [bugz 6737], using service ovsrepositories start. (restart will umount /OVS,
  then the nodes need to rejoin the DLM domain)
- [bugz 6717], local formated ocfs2 should not pass HA prerequisite check.

* Mon Jul 21 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-43
- [bugz 6707], prevent double mount on /OVS
- [bugz 6731], unregister master, when unregister server from pool

* Thu Jul 17 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-42
- replace tunefs.ocfs2 with debugfs.ocfs2 for segment fault bug.
- using debugfs to detect server failure.

* Wed Jul 16 2008 Tiger Zhang<tiger.zhang@oracle.com>
- implement v2v_cancel.
- add https support.

* Wed Jul 09 2008 Tiger Zhang<tiger.zhang@oracle.com>
- implement asynchronous v2v.
- add preference paramater to get_utility_server
- use share CDS in db_get_srv
- add share lock in OVSFileLock.py
- add procname utility
- add LOCK_SH support in OVSCDS.py

* Wed Jul 09 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-41
- restrict one server can only be registered to one pool
- treat "file:"/"tap:aio:" equal in xen_correct_cfg()

* Tue Jul 08 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-40
- allow user to specify disk position in add_vm_disk, returns front end name
- remove_vm_disk returns the orignal disk position
- new function check_hvm_pvdriver
- re-wrote test_url to remove potential bugs
- status inquery/cancel ability for create_vm_disk

* Mon Jul 07 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-40
- add dlm.py for xend external lock interface

* Sat Jul 05 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-39
- OVSCompat.py to use the compatible version of libvirt and python-virtinst

* Tue Jul 01 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-38
- ha_check_cluster_prerequisite()
- xen.xend.uuid need random.seed to initialize generator
- ha_generate_ocfs2_cluster_conf()

* Tue Jul 01 2008 Hongxi Ma<hongxi.ma@oracle.com> - 2.2-37
- Improved status inquery for ftp resource downloading
- support specifying 'keymap' while install new VM

* Sat Jun 28 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-36
- implement check cluster status
- implement dlm lock creation
- handle uuid, 1) if not exists add it 2)after cp update it

* Wed Jun 25 2008 Hongxi Ma<hongxi.ma@oracle.com> - 2.2-35
- new QoS agent interface to harmonise the new QoS implemtation in xend

* Wed Jun 25 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-35
- add OVSSiteHA.py, OVSXHA.py, OVSMonitorServer.py (not fully implemented yet)
- modify do_rpc.py, default to call local agent

* Wed Jun 25 2008 Tiger Zhang<tiger.zhang@oracle.com> - 2.2-34
- add sparse format(KDMV) support in vmdk parser
- fix du path containing spaces issue
- fix get_vmdk_list bug
- enhance converting process
- add checking free space and deleting downloaded files

* Wed Jun 18 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-34
- allow user to manual_shutdown when autostart is enabled

* Tue Jun 17 2008 Tiger Zhang<tiger.zhang@oracle.com> - 2.2-33
- Implement V2V without using vmware-vdiskmanager

* Tue Jun 17 2008 Hongxi Ma<hongxi.ma@oracle.com> - 2.2-33
- improved status inquery for resource importing
- async cancel ability improved

* Tue Jun 17 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-33
- when master nodes ready, sync the mount point on member nodes
- make the monitor->trigger->action based autorestart work

* Fri Jun 13 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-33
- [bugz 6425], xenstore-ls -> xenstore-read

* Tue Jun 10 2008 Hongxi Ma<hongxi.ma@oracle.com> - 2.2-32
- [bugz 6372], VD Priority Configuration in vm.cfg was not removed after delete a VD
- [bugz 6363], There are 2 QoS configures after change hard driver type
- get_vm_uptime, new interface to query the uptime of a vm
- utl_wget_status,improve the status query: success:filename:downloaded size:progress

* Tue Jun 10 2008 Tiger Zhang<tiger.zhan@oracle.com> - 2.2-32
- [bugz 6410], Can't not import a virtual machine image which locals in uuid repositories
- V2V, Add checking vmware-vdiskmanager before v2v convertion
- [bugz 6384], fixed cannot add more than 2 ide disk

* Tue Jun 10 2008 Dyno Fu <dyno.fu@oracle.com> - 2.2-32
- add OVSXSysInfo.py, implement get_oracle_vm_release(), get_agent_version()

* Fri Jun 6 2008 Tiger Zhang<tiger.zhang@oracle.com> - 2.2-32
- [bugz 6410], v2v source path with UUID

* Fri Jun 6 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-32
- [bugz 6384], fixed cannot add more than 2 ide disk

* Mon Jun 02 2008 Tiger Zhang<tiger.zhang@oracle.com>, Dyno Fu<dyno.fu@oracle.com>
  Hongxi Ma <hongxi.ma@oracle.com>  - 2.2-31
- V2V   Verify source directory
- [bugz 6180], vmware image import does not work on 2.1.2
- QoS   bugs fixing, new interfaces, tests
- test_url timeout enabled

* Tue May 27 2008 Tiger Zhang<tiger.zhang@oracle.com>, Dyno Fu<dyno.fu@oracle.com>
  Hongxi Ma <hongxi.ma@oracle.com>  - 2.2-30
- Add V2V feature
  V2V: Convert VMware vm to Oracle VM, integration with manager done
- Added api select_migration_target() to show the migration target at manager
  side
- QoS code (VIF part) done

* Tue May 20 2008 Hongxi Ma <hongxi.ma@oracle.com> - 2.2-29
- merged the cpu-pin and keymap

* Tue May 20 2008 Dyno Fu<dyno.fu@oracle.com> - 2.2-28
- implement remaster process for HA

* Wed Apr 30 2008 Dyno Fu<dyno.fu@oracle.com>
- using pid to track agent processes status

* Tue Mar 11 2008 Junjie Wei<junjie.wei@oracle.com>, Dyno Fu<dyno.fu@oracle.com>
- [bugz 5406], pxe boot failed after set vif

* Fri Mar 07 2008 Junjie Wei<junjie.wei@oracle.com>
- [bugz 5379], set timeout for testing connection
- [bugz 5380], deal with vif=['']
- [bugz 5381], will not automatically change the type of vif but return fail
- [bugz 5384], remove mac info from default vm.cfg for pvm PXE booting

* Tue Feb 28 2008 Dyno Fu<dyno.fu@oracle.com>
- [bugz 5318], implement get_free_memory()
- [bugz 5305], implement get_vm_avail_disk_slot()

* Tue Feb 26 2008 Hongxi Ma<hongxi.ma@oracle.com>
- [bugz 5305], rewrote next_fe_de

* Tue Feb 26 2008 Dyno Fu<dyno.fu@oracle.com>
- [bugz 5294], select_tgt_host() should use real_vm_path to check vm type

* Mon Feb 18 2008 Dyno Fu<dyno.fu@oracle.com>
- add version check for site agent operations for backward compatibility

* Wed Jan 31 2008 Dyno Fu<dyno.fu@oracle.com>
- [bugz 4731], add xen_/optimize_os_profile()

* Wed Jan 30 2008 Dyno Fu<dyno.fu@oracle.com>
- [bugz 4731], os profile support for hvm installation
- add xen_remove_shared_disk() when cp_vm() in the same site

* Wed Jan 30 2008 Hongxi Ma<hongxi.ma@oracle.com>
- [bugz 5120], new xen_get_network_bridges

* Tue Jan 29 2008 Junjie Wei<junjie.wei@oracle.com>
- [bugz 5039], utl_wget() download file/dir to temp dir .wget

* Thu Jan 25 2008 Dyno Fu<dyno.fu@oracle.com>
- set_vm_vifs()/xen_set_vifs() remove is_append add mode parameter
- get_servers_vcaps() to support datacollector to detect server hvm support

* Thu Jan 24 2008 Dyno Fu<dyno.fu@oracle.com>
- filter server without hardware caps to run the vm. add xen_hypervisor_info()

* Thu Jan 22 2008 Dyno Fu<dyno.fu@oracle.com>
- [bugz 5058], add remove cdrom functionality to change_vm_cdrom()

* Tue Jan 22 2008 Hongxi Ma<hongxi.ma@oracle.com>
- [bugz 3990], monitor wget status periodically in asynchronous mode.

* Mon Jan 21 2008 Hongxi Ma<hongxi.ma@oracle.com>
- add asynchronous task scheduler

* Thu Jan 17 2008 Dyno Fu<dyno.fu@oracle.com>
- [bugz 4561], add device type support for set/get vif configuration
- [bugz 4996], remove dump file vm.save after restore

* Thu Jan 17 2008 Hongxi Ma<hongxi.ma@oracle.com>
- [bugz 4712], set_vm_preferred_servers/get_vm_preferred_servers to support
  setting preferred servers for a VM

* Thu Jan 10 2008 Junjie Wei<junjie.wei@oracle.com>
- Keep cdrom during installation to support windows installation
- restore_vm(), install_vm_*() enhancement, dedicated servers supported
- rename suspend_vm()/resume_vm() to pause_vm()/unpause_vm(), in line with xm
- get_agent_version() implemented
- config_boot_sequence() implemented, boot from hard disk, cdrom or network
- get_host_info() enhancement, xen_caps info included
- rename get_hw_caps() to get_xen_caps()
- add a file lock for vm.cfg to avoid write contention
- fixed [bugz 3994, 4888, 4679, 4242, 4706]

* Thu Jan 10 2008 Dyno Fu<dyno.fu@oracle.com>
- support up to 4 disks for hvm
- [bugz 4010], password modification will not take effect immediately
- [bugz 4707], modify vm configuration at runtime

* Tue Nov 13 2007 Dyno Fu<dyno.fu@oracle.com>
- [bugz 4536], donnot remove original type setting, only workaround
  not a full solution

* Sat Nov 10 2007 Dyno Fu<dyno.fu@oracle.com>, Junjie Wei<junjie.wei@oracle.com>
- Hid ssl configuration, [bugz 4479]
- Applied find_real_path() to cdrom/iso when install vm, [bugz 4483]
- Implemented get_target_path() for cross-site cp storage balance,
- Change remove() behavior, [bugz 4484]

* Fri Nov 09 2007 Kevin Lyons <kevin.x.lyons@oracle.com>
- Set ssl to enabled by default in agent.ini.default
- Added post install script to generate keys

* Sat Nov 03 2007 Dyno Fu<dyno.fu@oracle.com>
- impelent get_vm_vifs() & xen_get_vifs()

* Thu Nov 01 2007 Dyno Fu<dyno.fu@oracle.com>
- replace rpc.exp with rcp.py in favor of pexpect

* Thu Nov 01 2007 Dyno Fu<dyno.fu@oracle.com>
- replace parameter vif->vif_cfg in function install_vm*()

* Wed Oct 31 2007 Dyno Fu<dyno.fu@oracle.com>
- implement get_network_bridges(), set_vm_vifs(), clear_vm_vif_mac()

* Sat Oct 27 2007 Dyno Fu<dyno.fu@oracle.com>
- before migrate vm, check if the 2 server share same storage view.

* Sat Oct 27 2007 Junjie Wei<junjie.wei@oracle.com>
- set vm install, add params vnclisten, vncpasswd, tablet, keep-cdrom
  (patch virt-install required)

* Thu Oct 25 2007 Dyno Fu<dyno.fu@oracle.com>
- fix [bugz 3392], handle multiple partition

* Thu Oct 25 2007 Junjie Wei<junjie.wei@oracle.com>
- [bugz 4063],4013,4106,4107,4064
- implement check_shared_storage(), get_hw_caps(), get_host_arch() and is_bootable()

* Tue Oct 23 2007 Dyno Fu<dyno.fu@oracle.com>
- [bugz 3994,4008,4011,4022]

* Tue Oct 16 2007 Junjie Wei<junjie.wei@oracle.com>
- various bugfix
- implement get_host_info

* Wed Oct 10 2007 Junjie Wei<junjie.wei@oracle.com>
- fix [bugz 3750], do not log the vnc password
- remove uuid when install vm from scratch

* Sun Oct 9 2007 Dyno Fu<dyno.fu@oracle.com>
- modify utils/config_agent.py to fix various bugs.

* Sun Oct 1 2007 Dyno Fu<dyno.fu@oracle.com>
- rename ovsagent to ovs-agent

* Sun Sep 30 2007 Dyno Fu<dyno.fu@oracle.com>, Junjie Wei<junjie.wei@oracle.com>
- rewrite change cdrom function
- various bugfix

* Sat Sep 29 2007 Junjie Wei<junjie.wei@oracle.com>
- implement add_vm_vif, del_vm_vif, get_vm_vnc_password, set_vm_vnc_password

* Sat Sep 29 2007 Dyno Fu<dyno.fu@oracle.com>
- rewrite get_vms_perf, loop throu servers not vms
- patch db_recovery, consider more cases

* Tue Sep 25 2007 Dyno Fu<dyno.fu@oracle.com>, Junjie Wei<junjie.wei@oracle.com>
- complete all the functions implemented previous
- rewrite agtctl, add client timeout to tackle cannot quit
  when child process running problem.

* Wed Sep 19 2007 Dyno Fu<dyno.fu@oracle.com>
- implement ssl support, but disable by default
- reorganize code layout

* Wed Sep 5 2007 Junjie Wei<junjie.wei@oracle.com>, Dyno Fu<dyno.fu@oracle.com>
- implement vm installation from scratch (hvm & para)
- check free disk space before cp vm, create vm disk, vm installation etc
- update exported function inline document

* Tue Aug 21 2007 Dyno Fu <dyno.fu@oracle.com>
- rewrite OVSSiteAgent process logic
- implement get vnc connection string
- fix [bugz 3249], [bugz 3233]

* Tue Jul 24 2007 Dyno Fu <dyno.fu@oracle.com>
- reenable configure network, pass parameter throu kernel cmdline

* Sat Jul 21 2007 Dyno Fu <dyno.fu@oracle.com>
- start vm remove invalid disk path
- add default config file, try not to overwrite previous config
- various bugfix

* Thu Jul 19 2007 Dyno Fu <dyno.fu@oracle.com>
- better exception/error logging "err msg=> %s: %s" % (e.__class__.__name__, e)
- run_cmd handle cmd more consistently
- reorg site db
- add READLOCK status & reference counter 'readlock' to allow concurrent cp
- add license comment
- add security check for any write operation upon vm
- add register default site when agent start
- broadcast (mac, ip) & get mac with xm list --long (in fact alot of other information)
- implement /etc/init.d/ovsagent configure

* Thu May 25 2007 Dyno Fu <dyno.fu@oracle.com>
- modify post configuration

* Thu Jan 11 2007 Zhigang Wang <zhigang.x.wang@oracle.com>
- initial ovsagent spec file
